// Test ampli a gain programmable avec reference programmable
// C.Dupaty BTS SE Lycee Fourcade 13120 Gardanne
// V1 06-2011

#include <p18f2620.h>
#include <stdio.h>
#include "mcp4821.h"		// lib pour mcp4821
#include "mcp6s21.h"		// lib pour mcp6s21
#include "init_horloge_interne.h"	// PIC2620 sur horloge interne FOSC=32Mhz

#define rmax	4095	// valeur max du DAC mcp4821, 12bits  
#define gmax	7		// valeur max du dode de gain pour le mcp6s21
#define gplus 1			// PORTB0=1
#define gmoins 2		// PORTB1=1
#define refplus 4		// PORTB2=1
#define refmoins 8		// PORTB3=1

unsigned char gain[]={1,2,4,5,8,10,16,32};  // Gains possibles sur mcp6s21 (pour affichage)

unsigned int r=0;	// valeur actuelle de la reference
unsigned char g=0;	// valeur actuelle du gain
unsigned char etat;	// variable pour memo derniere commande

void init_uart(void)	// l uart est utilisee pour l affichage du gain et de la reference
{						// 9600,n,8,1 pour F0SC=32Mhz
	TXSTA = 0b00100000; 	                  
	RCSTA = 0b10010000;	
	PIE1bits.TXIE=0;	// IT en emission dsactive
	PIE1bits.RCIE=0;	// IT en reception dactive 
	BAUDCONbits.BRG16=0;	
	TXSTAbits.BRGH=0;		
	SPBRG = 51;
}

void main(void)
{
	init_horloge_interne();
	init_uart();
	init_4821();
	init_6s21();
	TRISCbits.TRISC6=0; // TX usart
	TRISB=0b11111111;	// entrees utilisateur, une seule a 1 a la fois 
	r=2048;				// valeur reference de debut
	g=0;				// valeur de gain de debut (x1)
	emet_4821(0,r);					
	emet_6s21(g);
	etat=0;
	printf(" Ampli gain programmable \r\n");
	printf(" Commande par 1, revenir a 0 avant la suivante\n\r");
		while(1)
			{
				while (etat==PORTB);  	// attend un changement sur PORTB
				etat=PORTB;				// le memorise
				switch (PORTB) 
					{
						case 1 :   emet_6s21(g++); 		// emission nouveau gain
									if (g>gmax) g--;	// ne depasse pas max
									break;
						case 2 :   emet_6s21(g--); 
									if (g>gmax) g=0;
									break;
						case 4 :   emet_4821(0,r);
									r+=100;
									if (r>rmax) r-=100;
									break;
						case 8 :   emet_4821(0,r);
									r-=100 ;
									if (r>rmax) r=0;
									break;
						default:
									break;
					}
					// affichage gain et refence
					if (PORTB) printf("Gain : %d x%d ref : %d %dmV\n\r",g,gain[g],r,r);
			}
}
