// Test ampli a gain programmable avec reference programmable
// C.Dupaty BTS SE Lycee Fourcade 13120 Gardanne
// V1 06-2011

// reglage automatique valeur moyenne

#include <p18f2620.h>
#include <stdio.h>
#include "mcp4821.h"		// lib pour mcp4821
#include "mcp6s21.h"		// lib pour mcp6s21
#include "init_horloge_interne.h"	// PIC2620 sur horloge interne FOSC=32Mhz

#define rmax	4095	// valeur max du DAC mcp4821, 12bits  
#define gmax	7		// valeur max du dode de gain pour le mcp6s21
#define gplus 1			// PORTB0=1
#define gmoins 2		// PORTB1=1
#define vmoy 512

unsigned char gain[]={1,2,4,5,8,10,16,32};  // Gains possibles sur mcp6s21 (pour affichage)

int r=0;	// valeur actuelle de la reference
char g=0;	// valeur actuelle du gain
unsigned char etat;	// variable pour memo derniere commande
unsigned int mes;	// mesure vm sur CAN

void init_uart(void)	// l uart est utilisee pour l affichage du gain et de la reference
{						// 9600,n,8,1 pour F0SC=32Mhz
	TXSTA = 0b00100000; 	                  
	RCSTA = 0b10010000;	
	PIE1bits.TXIE=0;	// IT en emission dsactive
	PIE1bits.RCIE=0;	// IT en reception dactive 
	BAUDCONbits.BRG16=0;	
	TXSTAbits.BRGH=0;		
	SPBRG = 51;
}


unsigned int lecture_AN0(void)
{
	ADCON0bits.GO_DONE=1;
	while (ADCON0bits.GO_DONE);
	return ADRES;	
}

void ajuste_vm(void)
{unsigned int i;
	do
		{
			i=2000;
			while(i--);
			mes=lecture_AN0();
			if (mes < vmoy) {
							emet_4821(0,r);
							if (r!=0) r--;
							}
			if (mes > vmoy) 	{
							emet_4821(0,r);
							if (r<rmax) r++;
							}
		}
	while (mes!=vmoy);
	
	
}

void main(void)
{
	init_horloge_interne();
	init_uart();
	init_4821();
	init_6s21();
	ADCON0=0b00000001;
	ADCON1=0b00001110;
	ADCON2=0b10100100;
	TRISCbits.TRISC6=0; // TX usart
	TRISB=0b11111111;	// entrees utilisateur, une seule a 1 a la fois 
	r=2400;				// valeur reference de debut
	g=2;				// valeur de gain de debut (x2)
	emet_4821(0,r);					
	emet_6s21(g);

	etat=0;
	printf(" Ampli gain programmable \r\n");
	printf(" reglage automatique de la valeur moyenne\n\r");
		while(1)
			{
				while (etat==PORTB);  	// attend un changement sur PORTB
				etat=PORTB;				// le memorise
				switch (PORTB) 
					{
						case 1 :  	if (g<gmax) g++;	// ne depasse pas max
									emet_6s21(g); 		// emission nouveau gain
									ajuste_vm();
									printf("Gain:%d x%d ref:%d %dmV mes:%d \n\r",g,gain[g],r,r,mes);
									break;
						case 2 :  	if (g>0) g--;
									emet_6s21(g);
									ajuste_vm();
									printf("Gain:%d x%d ref:%d %dmV mes:%d \n\r",g,gain[g],r,r,mes);
									break;
						default:
									break;
					}	 
			}
}
