// bibliotheque pour MCP4821 DAC
// C.Dupaty 06/2011
#include <p18f2620.h>
#include "mcp4821.h"

#define SCLK PORTCbits.RC3
#define TRIS_SCLK TRISCbits.TRISC3
#define SDOUT PORTCbits.RC5
#define TRIS_SDOUT TRISCbits.TRISC5

void init_4821(void)  // initialisise SPI sur PIC18
{
	TRIS_CS_MCP4821=0;	// Ports en sortie
	TRIS_SCLK=0;
	TRIS_SDOUT=0;
	CS_MCP4821=1;		
	SSPSTAT=0b01000000; //echantillonne au milieu de la donne, sur front montant
	SSPCON1=0b00100010;	// active SPI, IDLE=0, clock=FOSC/64
	PIR1bits.SSPIF=0;	// SSPIF indique une fin d'emmission par un 1
}

void emet_4821(unsigned char ga,unsigned int v)
{
unsigned char fort,faible;
		fort=v>>8;	//fabrique PF et pf pour 4821 
		faible=v & 0b0000000011111111;
		if (ga==1) fort|=0b00100000; // positionne bit de gain interne
		fort|=0b00010000;			// sortie 1 (il n y en a qu'une sur 4821
		CS_MCP4821=0;				// debut emission
		PIR1bits.SSPIF=0;
		SSPBUF=fort;			// emmission poids forts		 
		while(!PIR1bits.SSPIF);	// attend la fin de l'mission
		PIR1bits.SSPIF=0;
		SSPBUF=faible;			// emmission poids faibles
		while(!PIR1bits.SSPIF); // attend la fin de l'mission
		CS_MCP4821=1;
}

