// bibliotheque pour MCP6S21 AGP
// C.Dupaty 06/2011

#include <p18f2620.h>
#include "mcp6s21.h"

#define SCLK PORTCbits.RC3
#define TRIS_SCLK TRISCbits.TRISC3
#define SDOUT PORTCbits.RC5
#define TRIS_SDOUT TRISCbits.TRISC5

void init_6s21(void)  // initialisise SPI sur PIC18
{
	TRIS_CS_MCP6s21=0; // ports en sortie
	TRIS_SCLK=0;
	TRIS_SDOUT=0;
	CS_MCP6s21=1;
	SSPSTAT=0b01000000; //echantillonne au milieu de la donne, sur front montant
	SSPCON1=0b00100010;	// active SPI, IDLE=0, clock=FOSC/64
	PIR1bits.SSPIF=0;	// SSPIF indique une fin d'emmission par un 1
	CS_MCP6s21=0;
	SSPBUF=0b01000001;			// selection canal (un seul sur mcp6s21		 
	while(!PIR1bits.SSPIF);	// attend la fin de l'mission
	PIR1bits.SSPIF=0;
	SSPBUF=0;			// canal 0
	while(!PIR1bits.SSPIF); // attend la fin de l'mission
	CS_MCP6s21=1;
}

void emet_6s21(unsigned char gain)
{
		CS_MCP6s21=0;		// debut emission
		PIR1bits.SSPIF=0;	
		SSPBUF=0b01000000;			// emmission poids forts	
		while(!PIR1bits.SSPIF);	// attend la fin de l'mission
		PIR1bits.SSPIF=0;
		SSPBUF=gain;			// emmission poids faibles
		while(!PIR1bits.SSPIF); // attend la fin de l'mission
		CS_MCP6s21=1;	// transfert du nouveau gain
}

